diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/template.php ./wordpress-3.4/wp-includes/template.php
*** ./wordpress-3.3.2/wp-includes/template.php	1969-12-31 18:00:00.000000000 -0600
--- ./wordpress-3.4/wp-includes/template.php	2012-05-24 02:06:13.000000000 -0500
***************
*** 0 ****
--- 1,394 ----
+ <?php
+ /**
+  * Template loading functions.
+  *
+  * @package WordPress
+  * @subpackage Template
+  */
+ 
+ /**
+  * Retrieve path to a template
+  *
+  * Used to quickly retrieve the path of a template without including the file
+  * extension. It will also check the parent theme, if the file exists, with
+  * the use of {@link locate_template()}. Allows for more generic template location
+  * without the use of the other get_*_template() functions.
+  *
+  * @since 1.5.0
+  *
+  * @param string $type Filename without extension.
+  * @param array $templates An optional list of template candidates
+  * @return string Full path to file.
+  */
+ function get_query_template( $type, $templates = array() ) {
+ 	$type = preg_replace( '|[^a-z0-9-]+|', '', $type );
+ 
+ 	if ( empty( $templates ) )
+ 		$templates = array("{$type}.php");
+ 
+ 	return apply_filters( "{$type}_template", locate_template( $templates ) );
+ }
+ 
+ /**
+  * Retrieve path of index template in current or parent template.
+  *
+  * @since 3.0.0
+  *
+  * @return string
+  */
+ function get_index_template() {
+ 	return get_query_template('index');
+ }
+ 
+ /**
+  * Retrieve path of 404 template in current or parent template.
+  *
+  * @since 1.5.0
+  *
+  * @return string
+  */
+ function get_404_template() {
+ 	return get_query_template('404');
+ }
+ 
+ /**
+  * Retrieve path of archive template in current or parent template.
+  *
+  * @since 1.5.0
+  *
+  * @return string
+  */
+ function get_archive_template() {
+ 	$post_type = get_query_var( 'post_type' );
+ 
+ 	$templates = array();
+ 
+ 	if ( $post_type )
+ 		$templates[] = "archive-{$post_type}.php";
+ 	$templates[] = 'archive.php';
+ 
+ 	return get_query_template( 'archive', $templates );
+ }
+ 
+ /**
+  * Retrieve path of author template in current or parent template.
+  *
+  * @since 1.5.0
+  *
+  * @return string
+  */
+ function get_author_template() {
+ 	$author = get_queried_object();
+ 
+ 	$templates = array();
+ 
+ 	$templates[] = "author-{$author->user_nicename}.php";
+ 	$templates[] = "author-{$author->ID}.php";
+ 	$templates[] = 'author.php';
+ 
+ 	return get_query_template( 'author', $templates );
+ }
+ 
+ /**
+  * Retrieve path of category template in current or parent template.
+  *
+  * Works by first retrieving the current slug for example 'category-default.php' and then
+  * trying category ID, for example 'category-1.php' and will finally fallback to category.php
+  * template, if those files don't exist.
+  *
+  * @since 1.5.0
+  * @uses apply_filters() Calls 'category_template' on file path of category template.
+  *
+  * @return string
+  */
+ function get_category_template() {
+ 	$category = get_queried_object();
+ 
+ 	$templates = array();
+ 
+ 	$templates[] = "category-{$category->slug}.php";
+ 	$templates[] = "category-{$category->term_id}.php";
+ 	$templates[] = 'category.php';
+ 
+ 	return get_query_template( 'category', $templates );
+ }
+ 
+ /**
+  * Retrieve path of tag template in current or parent template.
+  *
+  * Works by first retrieving the current tag name, for example 'tag-wordpress.php' and then
+  * trying tag ID, for example 'tag-1.php' and will finally fallback to tag.php
+  * template, if those files don't exist.
+  *
+  * @since 2.3.0
+  * @uses apply_filters() Calls 'tag_template' on file path of tag template.
+  *
+  * @return string
+  */
+ function get_tag_template() {
+ 	$tag = get_queried_object();
+ 
+ 	$templates = array();
+ 
+ 	$templates[] = "tag-{$tag->slug}.php";
+ 	$templates[] = "tag-{$tag->term_id}.php";
+ 	$templates[] = 'tag.php';
+ 
+ 	return get_query_template( 'tag', $templates );
+ }
+ 
+ /**
+  * Retrieve path of taxonomy template in current or parent template.
+  *
+  * Retrieves the taxonomy and term, if term is available. The template is
+  * prepended with 'taxonomy-' and followed by both the taxonomy string and
+  * the taxonomy string followed by a dash and then followed by the term.
+  *
+  * The taxonomy and term template is checked and used first, if it exists.
+  * Second, just the taxonomy template is checked, and then finally, taxonomy.php
+  * template is used. If none of the files exist, then it will fall back on to
+  * index.php.
+  *
+  * @since 2.5.0
+  * @uses apply_filters() Calls 'taxonomy_template' filter on found path.
+  *
+  * @return string
+  */
+ function get_taxonomy_template() {
+ 	$term = get_queried_object();
+ 	$taxonomy = $term->taxonomy;
+ 
+ 	$templates = array();
+ 
+ 	$templates[] = "taxonomy-$taxonomy-{$term->slug}.php";
+ 	$templates[] = "taxonomy-$taxonomy.php";
+ 	$templates[] = 'taxonomy.php';
+ 
+ 	return get_query_template( 'taxonomy', $templates );
+ }
+ 
+ /**
+  * Retrieve path of date template in current or parent template.
+  *
+  * @since 1.5.0
+  *
+  * @return string
+  */
+ function get_date_template() {
+ 	return get_query_template('date');
+ }
+ 
+ /**
+  * Retrieve path of home template in current or parent template.
+  *
+  * This is the template used for the page containing the blog posts
+  *
+  * Attempts to locate 'home.php' first before falling back to 'index.php'.
+  *
+  * @since 1.5.0
+  * @uses apply_filters() Calls 'home_template' on file path of home template.
+  *
+  * @return string
+  */
+ function get_home_template() {
+ 	$templates = array( 'home.php', 'index.php' );
+ 
+ 	return get_query_template( 'home', $templates );
+ }
+ 
+ /**
+  * Retrieve path of front-page template in current or parent template.
+  *
+  * Looks for 'front-page.php'.
+  *
+  * @since 3.0.0
+  * @uses apply_filters() Calls 'front_page_template' on file path of template.
+  *
+  * @return string
+  */
+ function get_front_page_template() {
+ 	$templates = array('front-page.php');
+ 
+ 	return get_query_template( 'front_page', $templates );
+ }
+ 
+ /**
+  * Retrieve path of page template in current or parent template.
+  *
+  * Will first look for the specifically assigned page template
+  * The will search for 'page-{slug}.php' followed by 'page-id.php'
+  * and finally 'page.php'
+  *
+  * @since 1.5.0
+  *
+  * @return string
+  */
+ function get_page_template() {
+ 	$id = get_queried_object_id();
+ 	$template = get_page_template_slug();
+ 	$pagename = get_query_var('pagename');
+ 
+ 	if ( ! $pagename && $id ) {
+ 		// If a static page is set as the front page, $pagename will not be set. Retrieve it from the queried object
+ 		$post = get_queried_object();
+ 		$pagename = $post->post_name;
+ 	}
+ 
+ 	$templates = array();
+ 	if ( $template && 0 === validate_file( $template ) )
+ 		$templates[] = $template;
+ 	if ( $pagename )
+ 		$templates[] = "page-$pagename.php";
+ 	if ( $id )
+ 		$templates[] = "page-$id.php";
+ 	$templates[] = 'page.php';
+ 
+ 	return get_query_template( 'page', $templates );
+ }
+ 
+ /**
+  * Retrieve path of paged template in current or parent template.
+  *
+  * @since 1.5.0
+  *
+  * @return string
+  */
+ function get_paged_template() {
+ 	return get_query_template('paged');
+ }
+ 
+ /**
+  * Retrieve path of search template in current or parent template.
+  *
+  * @since 1.5.0
+  *
+  * @return string
+  */
+ function get_search_template() {
+ 	return get_query_template('search');
+ }
+ 
+ /**
+  * Retrieve path of single template in current or parent template.
+  *
+  * @since 1.5.0
+  *
+  * @return string
+  */
+ function get_single_template() {
+ 	$object = get_queried_object();
+ 
+ 	$templates = array();
+ 
+ 	$templates[] = "single-{$object->post_type}.php";
+ 	$templates[] = "single.php";
+ 
+ 	return get_query_template( 'single', $templates );
+ }
+ 
+ /**
+  * Retrieve path of attachment template in current or parent template.
+  *
+  * The attachment path first checks if the first part of the mime type exists.
+  * The second check is for the second part of the mime type. The last check is
+  * for both types separated by an underscore. If neither are found then the file
+  * 'attachment.php' is checked and returned.
+  *
+  * Some examples for the 'text/plain' mime type are 'text.php', 'plain.php', and
+  * finally 'text_plain.php'.
+  *
+  * @since 2.0.0
+  *
+  * @return string
+  */
+ function get_attachment_template() {
+ 	global $posts;
+ 	$type = explode('/', $posts[0]->post_mime_type);
+ 	if ( $template = get_query_template($type[0]) )
+ 		return $template;
+ 	elseif ( $template = get_query_template($type[1]) )
+ 		return $template;
+ 	elseif ( $template = get_query_template("$type[0]_$type[1]") )
+ 		return $template;
+ 	else
+ 		return get_query_template('attachment');
+ }
+ 
+ /**
+  * Retrieve path of comment popup template in current or parent template.
+  *
+  * Checks for comment popup template in current template, if it exists or in the
+  * parent template.
+  *
+  * @since 1.5.0
+  * @uses apply_filters() Calls 'comments_popup_template' filter on path.
+  *
+  * @return string
+  */
+ function get_comments_popup_template() {
+ 	$template = get_query_template( 'comments_popup', array( 'comments-popup.php' ) );
+ 
+ 	// Backward compat code will be removed in a future release
+ 	if ('' == $template)
+ 		$template = ABSPATH . WPINC . '/theme-compat/comments-popup.php';
+ 
+ 	return $template;
+ }
+ 
+ /**
+  * Retrieve the name of the highest priority template file that exists.
+  *
+  * Searches in the STYLESHEETPATH before TEMPLATEPATH so that themes which
+  * inherit from a parent theme can just overload one file.
+  *
+  * @since 2.7.0
+  *
+  * @param string|array $template_names Template file(s) to search for, in order.
+  * @param bool $load If true the template file will be loaded if it is found.
+  * @param bool $require_once Whether to require_once or require. Default true. Has no effect if $load is false.
+  * @return string The template filename if one is located.
+  */
+ function locate_template($template_names, $load = false, $require_once = true ) {
+ 	$located = '';
+ 	foreach ( (array) $template_names as $template_name ) {
+ 		if ( !$template_name )
+ 			continue;
+ 		if ( file_exists(STYLESHEETPATH . '/' . $template_name)) {
+ 			$located = STYLESHEETPATH . '/' . $template_name;
+ 			break;
+ 		} else if ( file_exists(TEMPLATEPATH . '/' . $template_name) ) {
+ 			$located = TEMPLATEPATH . '/' . $template_name;
+ 			break;
+ 		}
+ 	}
+ 
+ 	if ( $load && '' != $located )
+ 		load_template( $located, $require_once );
+ 
+ 	return $located;
+ }
+ 
+ /**
+  * Require the template file with WordPress environment.
+  *
+  * The globals are set up for the template file to ensure that the WordPress
+  * environment is available from within the function. The query variables are
+  * also available.
+  *
+  * @since 1.5.0
+  *
+  * @param string $_template_file Path to template file.
+  * @param bool $require_once Whether to require_once or require. Default true.
+  */
+ function load_template( $_template_file, $require_once = true ) {
+ 	global $posts, $post, $wp_did_header, $wp_query, $wp_rewrite, $wpdb, $wp_version, $wp, $id, $comment, $user_ID;
+ 
+ 	if ( is_array( $wp_query->query_vars ) )
+ 		extract( $wp_query->query_vars, EXTR_SKIP );
+ 
+ 	if ( $require_once )
+ 		require_once( $_template_file );
+ 	else
+ 		require( $_template_file );
+ }
+ 
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/theme.php ./wordpress-3.4/wp-includes/theme.php
*** ./wordpress-3.3.2/wp-includes/theme.php	2011-11-14 17:56:18.000000000 -0600
--- ./wordpress-3.4/wp-includes/theme.php	2012-06-12 10:57:11.000000000 -0500
***************
*** 3,12 ****
   * Theme, template, and stylesheet functions.
   *
   * @package WordPress
!  * @subpackage Template
   */
  
  /**
   * Whether a child theme is in use.
   *
   * @since 3.0.0
--- 3,112 ----
   * Theme, template, and stylesheet functions.
   *
   * @package WordPress
!  * @subpackage Theme
   */
  
  /**
+  * Returns an array of WP_Theme objects based on the arguments.
+  *
+  * Despite advances over get_themes(), this function is quite expensive, and grows
+  * linearly with additional themes. Stick to wp_get_theme() if possible.
+  *
+  * @since 3.4.0
+  *
+  * @param array $args The search arguments. Optional.
+  * - errors      mixed  True to return themes with errors, false to return themes without errors, null
+  *                      to return all themes. Defaults to false.
+  * - allowed     mixed  (Multisite) True to return only allowed themes for a site. False to return only
+  *                      disallowed themes for a site. 'site' to return only site-allowed themes. 'network'
+  *                      to return only network-allowed themes. Null to return all themes. Defaults to null.
+  * - blog_id     int    (Multisite) The blog ID used to calculate which themes are allowed. Defaults to 0,
+  *                      synonymous for the current blog.
+  * @return Array of WP_Theme objects.
+  */
+ function wp_get_themes( $args = array() ) {
+ 	global $wp_theme_directories;
+ 
+ 	$defaults = array( 'errors' => false, 'allowed' => null, 'blog_id' => 0 );
+ 	$args = wp_parse_args( $args, $defaults );
+ 
+ 	$theme_directories = search_theme_directories();
+ 
+ 	if ( count( $wp_theme_directories ) > 1 ) {
+ 		// Make sure the current theme wins out, in case search_theme_directories() picks the wrong
+ 		// one in the case of a conflict. (Normally, last registered theme root wins.)
+ 		$current_theme = get_stylesheet();
+ 		if ( isset( $theme_directories[ $current_theme ] ) ) {
+ 			$root_of_current_theme = get_raw_theme_root( $current_theme );
+ 			if ( ! in_array( $root_of_current_theme, $wp_theme_directories ) )
+ 				$root_of_current_theme = WP_CONTENT_DIR . $root_of_current_theme;
+ 			$theme_directories[ $current_theme ]['theme_root'] = $root_of_current_theme;
+ 		}
+ 	}
+ 
+ 	if ( empty( $theme_directories ) )
+ 		return array();
+ 
+ 	if ( is_multisite() && null !== $args['allowed'] ) {
+ 		$allowed = $args['allowed'];
+ 		if ( 'network' === $allowed )
+ 			$theme_directories = array_intersect_key( $theme_directories, WP_Theme::get_allowed_on_network() );
+ 		elseif ( 'site' === $allowed )
+ 			$theme_directories = array_intersect_key( $theme_directories, WP_Theme::get_allowed_on_site( $args['blog_id'] ) );
+ 		elseif ( $allowed )
+ 			$theme_directories = array_intersect_key( $theme_directories, WP_Theme::get_allowed( $args['blog_id'] ) );
+ 		else
+ 			$theme_directories = array_diff_key( $theme_directories, WP_Theme::get_allowed( $args['blog_id'] ) );
+ 	}
+ 
+ 	$themes = array();
+ 	static $_themes = array();
+ 
+ 	foreach ( $theme_directories as $theme => $theme_root ) {
+ 		if ( isset( $_themes[ $theme_root['theme_root'] . '/' . $theme ] ) )
+ 			$themes[ $theme ] = $_themes[ $theme_root['theme_root'] . '/' . $theme ];
+ 		else
+ 			$themes[ $theme ] = $_themes[ $theme_root['theme_root'] . '/' . $theme ] = new WP_Theme( $theme, $theme_root['theme_root'] );
+ 	}
+ 
+ 	if ( null !== $args['errors'] ) {
+ 		foreach ( $themes as $theme => $wp_theme ) {
+ 			if ( $wp_theme->errors() != $args['errors'] )
+ 				unset( $themes[ $theme ] );
+ 		}
+ 	}
+ 
+ 	return $themes;
+ }
+ 
+ /**
+  * Gets a WP_Theme object for a theme.
+  *
+  * @since 3.4.0
+  *
+  * @param string $stylesheet Directory name for the theme. Optional. Defaults to current theme.
+  * @param string $theme_root Absolute path of the theme root to look in. Optional. If not specified, get_raw_theme_root()
+  * 	is used to calculate the theme root for the $stylesheet provided (or current theme).
+  * @return WP_Theme Theme object. Be sure to check the object's exists() method if you need to confirm the theme's existence.
+  */
+ function wp_get_theme( $stylesheet = null, $theme_root = null ) {
+ 	global $wp_theme_directories;
+ 
+ 	if ( empty( $stylesheet ) )
+ 		$stylesheet = get_stylesheet();
+ 
+ 	if ( empty( $theme_root ) ) {
+ 		$theme_root = get_raw_theme_root( $stylesheet );
+ 		if ( false === $theme_root )
+ 			$theme_root = WP_CONTENT_DIR . '/themes';
+ 		elseif ( ! in_array( $theme_root, (array) $wp_theme_directories ) )
+ 			$theme_root = WP_CONTENT_DIR . $theme_root;
+ 	}
+ 
+ 	return new WP_Theme( $stylesheet, $theme_root );
+ }
+ 
+ /**
   * Whether a child theme is in use.
   *
   * @since 3.0.0
***************
*** 161,470 ****
  }
  
  /**
-  * Retrieve theme data from parsed theme file.
-  *
-  * The description will have the tags filtered with the following HTML elements
-  * whitelisted. The <b>'a'</b> element with the <em>href</em> and <em>title</em>
-  * attributes. The <b>abbr</b> element with the <em>title</em> attribute. The
-  * <b>acronym</b> element with the <em>title</em> attribute allowed. The
-  * <b>code</b>, <b>em</b>, and <b>strong</b> elements also allowed.
-  *
-  * The style.css file must contain theme name, theme URI, and description. The
-  * data can also contain author URI, author, template (parent template),
-  * version, status, and finally tags. Some of these are not used by WordPress
-  * administration panels, but are used by theme directory web sites which list
-  * the theme.
-  *
-  * @since 1.5.0
-  *
-  * @param string $theme_file Theme file path.
-  * @return array Theme data.
-  */
- function get_theme_data( $theme_file ) {
- 	$default_headers = array(
- 		'Name' => 'Theme Name',
- 		'URI' => 'Theme URI',
- 		'Description' => 'Description',
- 		'Author' => 'Author',
- 		'AuthorURI' => 'Author URI',
- 		'Version' => 'Version',
- 		'Template' => 'Template',
- 		'Status' => 'Status',
- 		'Tags' => 'Tags'
- 		);
- 
- 	$themes_allowed_tags = array(
- 		'a' => array(
- 			'href' => array(),'title' => array()
- 			),
- 		'abbr' => array(
- 			'title' => array()
- 			),
- 		'acronym' => array(
- 			'title' => array()
- 			),
- 		'code' => array(),
- 		'em' => array(),
- 		'strong' => array()
- 	);
- 
- 	$theme_data = get_file_data( $theme_file, $default_headers, 'theme' );
- 
- 	$theme_data['Name'] = $theme_data['Title'] = wp_kses( $theme_data['Name'], $themes_allowed_tags );
- 
- 	$theme_data['URI'] = esc_url( $theme_data['URI'] );
- 
- 	$theme_data['Description'] = wptexturize( wp_kses( $theme_data['Description'], $themes_allowed_tags ) );
- 
- 	$theme_data['AuthorURI'] = esc_url( $theme_data['AuthorURI'] );
- 
- 	$theme_data['Template'] = wp_kses( $theme_data['Template'], $themes_allowed_tags );
- 
- 	$theme_data['Version'] = wp_kses( $theme_data['Version'], $themes_allowed_tags );
- 
- 	if ( $theme_data['Status'] == '' )
- 		$theme_data['Status'] = 'publish';
- 	else
- 		$theme_data['Status'] = wp_kses( $theme_data['Status'], $themes_allowed_tags );
- 
- 	if ( $theme_data['Tags'] == '' )
- 		$theme_data['Tags'] = array();
- 	else
- 		$theme_data['Tags'] = array_map( 'trim', explode( ',', wp_kses( $theme_data['Tags'], array() ) ) );
- 
- 	if ( $theme_data['Author'] == '' ) {
- 		$theme_data['Author'] = $theme_data['AuthorName'] = __('Anonymous');
- 	} else {
- 		$theme_data['AuthorName'] = wp_kses( $theme_data['Author'], $themes_allowed_tags );
- 		if ( empty( $theme_data['AuthorURI'] ) ) {
- 			$theme_data['Author'] = $theme_data['AuthorName'];
- 		} else {
- 			$theme_data['Author'] = sprintf( '<a href="%1$s" title="%2$s">%3$s</a>', $theme_data['AuthorURI'], esc_attr__( 'Visit author homepage' ), $theme_data['AuthorName'] );
- 		}
- 	}
- 
- 	return $theme_data;
- }
- 
- /**
-  * Retrieve list of themes with theme data in theme directory.
-  *
-  * The theme is broken, if it doesn't have a parent theme and is missing either
-  * style.css and, or index.php. If the theme has a parent theme then it is
-  * broken, if it is missing style.css; index.php is optional. The broken theme
-  * list is saved in the {@link $wp_broken_themes} global, which is displayed on
-  * the theme list in the administration panels.
-  *
-  * @since 1.5.0
-  * @global array $wp_broken_themes Stores the broken themes.
-  * @global array $wp_themes Stores the working themes.
-  *
-  * @return array Theme list with theme data.
-  */
- function get_themes() {
- 	global $wp_themes, $wp_broken_themes;
- 
- 	if ( isset($wp_themes) )
- 		return $wp_themes;
- 
- 	if ( !$theme_files = search_theme_directories() )
- 		return false;
- 
- 	asort( $theme_files );
- 
- 	$wp_themes = array();
- 
- 	foreach ( (array) $theme_files as $theme_file ) {
- 		$theme_root = $theme_file['theme_root'];
- 		$theme_file = $theme_file['theme_file'];
- 
- 		if ( !is_readable("$theme_root/$theme_file") ) {
- 			$wp_broken_themes[$theme_file] = array('Name' => $theme_file, 'Title' => $theme_file, 'Description' => __('File not readable.'));
- 			continue;
- 		}
- 
- 		$theme_data = get_theme_data("$theme_root/$theme_file");
- 
- 		$name        = $theme_data['Name'];
- 		$title       = $theme_data['Title'];
- 		$description = wptexturize($theme_data['Description']);
- 		$version     = $theme_data['Version'];
- 		$author      = $theme_data['Author'];
- 		$template    = $theme_data['Template'];
- 		$stylesheet  = dirname($theme_file);
- 
- 		$screenshot = false;
- 		foreach ( array('png', 'gif', 'jpg', 'jpeg') as $ext ) {
- 			if (file_exists("$theme_root/$stylesheet/screenshot.$ext")) {
- 				$screenshot = "screenshot.$ext";
- 				break;
- 			}
- 		}
- 
- 		if ( empty($name) ) {
- 			$name = dirname($theme_file);
- 			$title = $name;
- 		}
- 
- 		$parent_template = $template;
- 
- 		if ( empty($template) ) {
- 			if ( file_exists("$theme_root/$stylesheet/index.php") )
- 				$template = $stylesheet;
- 			else
- 				continue;
- 		}
- 
- 		$template = trim( $template );
- 
- 		if ( !file_exists("$theme_root/$template/index.php") ) {
- 			$parent_dir = dirname(dirname($theme_file));
- 			if ( file_exists("$theme_root/$parent_dir/$template/index.php") ) {
- 				$template = "$parent_dir/$template";
- 				$template_directory = "$theme_root/$template";
- 			} else {
- 				/**
- 				 * The parent theme doesn't exist in the current theme's folder or sub folder
- 				 * so lets use the theme root for the parent template.
- 				 */
- 				if ( isset($theme_files[$template]) && file_exists( $theme_files[$template]['theme_root'] . "/$template/index.php" ) ) {
- 					$template_directory = $theme_files[$template]['theme_root'] . "/$template";
- 				} else {
- 					if ( empty( $parent_template) )
- 						$wp_broken_themes[$name] = array('Name' => $name, 'Title' => $title, 'Description' => __('Template is missing.'), 'error' => 'no_template');
- 					else
- 						$wp_broken_themes[$name] = array('Name' => $name, 'Title' => $title, 'Description' => sprintf( __('The parent theme is missing. Please install the "%s" parent theme.'),  $parent_template ), 'error' => 'no_parent', 'parent' => $parent_template );
- 					continue;
- 				}
- 
- 			}
- 		} else {
- 			$template_directory = trim( $theme_root . '/' . $template );
- 		}
- 
- 		$stylesheet_files = array();
- 		$template_files = array();
- 
- 		$stylesheet_dir = @ dir("$theme_root/$stylesheet");
- 		if ( $stylesheet_dir ) {
- 			while ( ($file = $stylesheet_dir->read()) !== false ) {
- 				if ( !preg_match('|^\.+$|', $file) ) {
- 					if ( preg_match('|\.css$|', $file) )
- 						$stylesheet_files[] = "$theme_root/$stylesheet/$file";
- 					elseif ( preg_match('|\.php$|', $file) )
- 						$template_files[] = "$theme_root/$stylesheet/$file";
- 				}
- 			}
- 			@ $stylesheet_dir->close();
- 		}
- 
- 		$template_dir = @ dir("$template_directory");
- 		if ( $template_dir ) {
- 			while ( ($file = $template_dir->read()) !== false ) {
- 				if ( preg_match('|^\.+$|', $file) )
- 					continue;
- 				if ( preg_match('|\.php$|', $file) ) {
- 					$template_files[] = "$template_directory/$file";
- 				} elseif ( is_dir("$template_directory/$file") ) {
- 					$template_subdir = @ dir("$template_directory/$file");
- 					if ( !$template_subdir )
- 						continue;
- 					while ( ($subfile = $template_subdir->read()) !== false ) {
- 						if ( preg_match('|^\.+$|', $subfile) )
- 							continue;
- 						if ( preg_match('|\.php$|', $subfile) )
- 							$template_files[] = "$template_directory/$file/$subfile";
- 					}
- 					@ $template_subdir->close();
- 				}
- 			}
- 			@ $template_dir->close();
- 		}
- 
- 		//Make unique and remove duplicates when stylesheet and template are the same i.e. most themes
- 		$template_files = array_unique($template_files);
- 		$stylesheet_files = array_unique($stylesheet_files);
- 
- 		$template_dir = $template_directory;
- 		$stylesheet_dir = $theme_root . '/' . $stylesheet;
- 
- 		if ( empty($template_dir) )
- 			$template_dir = '/';
- 		if ( empty($stylesheet_dir) )
- 			$stylesheet_dir = '/';
- 
- 		// Check for theme name collision.  This occurs if a theme is copied to
- 		// a new theme directory and the theme header is not updated.  Whichever
- 		// theme is first keeps the name.  Subsequent themes get a suffix applied.
- 		// The Twenty Eleven, Twenty Ten, Default and Classic themes always trump
- 		// their pretenders.
- 		if ( isset($wp_themes[$name]) ) {
- 			$trump_cards = array(
- 				'classic'      => 'WordPress Classic',
- 				'default'      => 'WordPress Default',
- 				'twentyten'    => 'Twenty Ten',
- 				'twentyeleven' => 'Twenty Eleven',
- 			);
- 			if ( isset( $trump_cards[ $stylesheet ] ) && $name == $trump_cards[ $stylesheet ] ) {
- 				// If another theme has claimed to be one of our default themes, move
- 				// them aside.
- 				$suffix = $wp_themes[$name]['Stylesheet'];
- 				$new_name = "$name/$suffix";
- 				$wp_themes[$new_name] = $wp_themes[$name];
- 				$wp_themes[$new_name]['Name'] = $new_name;
- 			} else {
- 				$name = "$name/$stylesheet";
- 			}
- 		}
- 
- 		$theme_roots[$stylesheet] = str_replace( WP_CONTENT_DIR, '', $theme_root );
- 		$wp_themes[$name] = array(
- 			'Name' => $name,
- 			'Title' => $title,
- 			'Description' => $description,
- 			'Author' => $author,
- 			'Author Name' => $theme_data['AuthorName'],
- 			'Author URI' => $theme_data['AuthorURI'],
- 			'Version' => $version,
- 			'Template' => $template,
- 			'Stylesheet' => $stylesheet,
- 			'Template Files' => $template_files,
- 			'Stylesheet Files' => $stylesheet_files,
- 			'Template Dir' => $template_dir,
- 			'Stylesheet Dir' => $stylesheet_dir,
- 			'Status' => $theme_data['Status'],
- 			'Screenshot' => $screenshot,
- 			'Tags' => $theme_data['Tags'],
- 			'Theme Root' => $theme_root,
- 			'Theme Root URI' => str_replace( WP_CONTENT_DIR, content_url(), $theme_root ),
- 		);
- 	}
- 
- 	unset($theme_files);
- 
- 	/* Store theme roots in the DB */
- 	if ( get_site_transient( 'theme_roots' ) != $theme_roots )
- 		set_site_transient( 'theme_roots', $theme_roots, 7200 ); // cache for two hours
- 	unset($theme_roots);
- 
- 	/* Resolve theme dependencies. */
- 	$theme_names = array_keys( $wp_themes );
- 	foreach ( (array) $theme_names as $theme_name ) {
- 		$wp_themes[$theme_name]['Parent Theme'] = '';
- 		if ( $wp_themes[$theme_name]['Stylesheet'] != $wp_themes[$theme_name]['Template'] ) {
- 			foreach ( (array) $theme_names as $parent_theme_name ) {
- 				if ( ($wp_themes[$parent_theme_name]['Stylesheet'] == $wp_themes[$parent_theme_name]['Template']) && ($wp_themes[$parent_theme_name]['Template'] == $wp_themes[$theme_name]['Template']) ) {
- 					$wp_themes[$theme_name]['Parent Theme'] = $wp_themes[$parent_theme_name]['Name'];
- 					break;
- 				}
- 			}
- 		}
- 	}
- 
- 	return $wp_themes;
- }
- 
- /**
   * Retrieve theme roots.
   *
   * @since 2.9.0
--- 261,266 ----
***************
*** 479,545 ****
  
  	$theme_roots = get_site_transient( 'theme_roots' );
  	if ( false === $theme_roots ) {
! 		get_themes();
! 		$theme_roots = get_site_transient( 'theme_roots' ); // this is set in get_theme()
  	}
  	return $theme_roots;
  }
  
  /**
-  * Retrieve theme data.
-  *
-  * @since 1.5.0
-  *
-  * @param string $theme Theme name.
-  * @return array|null Null, if theme name does not exist. Theme data, if exists.
-  */
- function get_theme($theme) {
- 	$themes = get_themes();
- 
- 	if ( is_array( $themes ) && array_key_exists( $theme, $themes ) )
- 		return $themes[$theme];
- 
- 	return null;
- }
- 
- /**
-  * Retrieve current theme display name.
-  *
-  * If the 'current_theme' option has already been set, then it will be returned
-  * instead. If it is not set, then each theme will be iterated over until both
-  * the current stylesheet and current template name.
-  *
-  * @since 1.5.0
-  *
-  * @return string
-  */
- function get_current_theme() {
- 	if ( $theme = get_option('current_theme') )
- 		return $theme;
- 
- 	$themes = get_themes();
- 	$current_theme = 'Twenty Eleven';
- 
- 	if ( $themes ) {
- 		$theme_names = array_keys( $themes );
- 		$current_template = get_option( 'template' );
- 		$current_stylesheet = get_option( 'stylesheet' );
- 
- 		foreach ( (array) $theme_names as $theme_name ) {
- 			if ( $themes[$theme_name]['Stylesheet'] == $current_stylesheet &&
- 					$themes[$theme_name]['Template'] == $current_template ) {
- 				$current_theme = $themes[$theme_name]['Name'];
- 				break;
- 			}
- 		}
- 	}
- 
- 	update_option('current_theme', $current_theme);
- 
- 	return $current_theme;
- }
- 
- /**
   * Register a directory that contains themes.
   *
   * @since 2.9.0
--- 275,287 ----
  
  	$theme_roots = get_site_transient( 'theme_roots' );
  	if ( false === $theme_roots ) {
! 		search_theme_directories( true ); // Regenerate the transient.
! 		$theme_roots = get_site_transient( 'theme_roots' );
  	}
  	return $theme_roots;
  }
  
  /**
   * Register a directory that contains themes.
   *
   * @since 2.9.0
***************
*** 547,567 ****
   * @param string $directory Either the full filesystem path to a theme folder or a folder within WP_CONTENT_DIR
   * @return bool
   */
! function register_theme_directory( $directory) {
  	global $wp_theme_directories;
  
! 	/* If this folder does not exist, return and do not register */
! 	if ( !file_exists( $directory ) )
! 			/* Try prepending as the theme directory could be relative to the content directory */
! 		$registered_directory = WP_CONTENT_DIR . '/' . $directory;
! 	else
! 		$registered_directory = $directory;
! 
! 	/* If this folder does not exist, return and do not register */
! 	if ( !file_exists( $registered_directory ) )
! 		return false;
  
! 	$wp_theme_directories[] = $registered_directory;
  
  	return true;
  }
--- 289,306 ----
   * @param string $directory Either the full filesystem path to a theme folder or a folder within WP_CONTENT_DIR
   * @return bool
   */
! function register_theme_directory( $directory ) {
  	global $wp_theme_directories;
  
! 	if ( ! file_exists( $directory ) ) {
! 		// Try prepending as the theme directory could be relative to the content directory
! 		$directory = WP_CONTENT_DIR . '/' . $directory;
! 		// If this directory does not exist, return and do not register
! 		if ( ! file_exists( $directory ) )
! 			return false;
! 	}
  
! 	$wp_theme_directories[] = $directory;
  
  	return true;
  }
